<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <auto-form
            ref="form"
            :default-data="formModel"
            :hidden-data="{
                id: formModel.id ?? '',
            }"
            :fields="formFields"
        />
        <div class="flex justify-end space-x-2">
            <auto-button
                :block="false"
                :disabled="form && form.busy ? form.busy : false"
                @click="submitForm"
            >
                {{ $t('submit') }}
            </auto-button>
        </div>
    </div>
</template>
<script setup>
import AutoForm from "~/components/auto-form.vue";
import {computed, onMounted, ref} from "vue";
import {useI18n} from "vue-i18n";
import axios from "axios";
import AutoButton from "~/components/button/auto-button.vue";

const props = defineProps({
    formModel: {
        required: false,
        type: Object,
        default: null,
    }
});

const emit = defineEmits(['update']);

const $i18n = useI18n();
const pageReady = ref(false);
const form = ref();
const model = ref();
const groups = ref([]);

const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'username',
            label: $i18n.t('username'),
        },
        {
            type: 'text',
            name: 'name',
            label: $i18n.t('name'),
        },
        {
            type: 'text',
            name: 'email',
            label: $i18n.t('email'),
        },
        ...(!props.formModel.id || String(props.formModel.type) === String(0) ? [
            {
                type: 'select',
                name: 'admin_group_id',
                label: $i18n.t('group'),
                placeholder: $i18n.t('please_select'),
                options: groups.value.map(r => {
                    return {
                        value: String(r.id),
                        text: r.group_name
                    };
                }),
            },
        ] : []),
        ...(props.formModel && props.formModel.id ? [
            {
                type: 'password',
                name: 'password',
                label: $i18n.t('new_password'),
                placeholder: $i18n.t('optional'),
                note: $i18n.t('leave_blank_if_not_changing')
            },
            {
                type: 'password',
                name: 'password_confirmation',
                label: $i18n.t('new_password_confirmation'),
                placeholder: $i18n.t('optional'),
                note: $i18n.t('leave_blank_if_not_changing')
            },
        ] : [
            {
                type: 'password',
                name: 'password',
                label: $i18n.t('password'),
            },
            {
                type: 'password',
                name: 'password_confirmation',
                label: $i18n.t('password_confirmation'),
            },
        ]),

    ]
});

const submitForm = async () => {
    try {
        const resp = await form.value.submitForm('/management/admin/submit_form');

        if (resp.model) {
            emit('update', resp.model);
        }
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    try {
        const data = await axios.post('/management/admin/build_form', {
            id: props.formModel ? props.formModel.id : '',
        });

        if (data.model) {
            model.value = data.model;
        }

        if (data.groups) {
            groups.value = data.groups;
        }

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});
</script>
